#define NULL_VALUE	-2147483639
#include "gen_dec.h"

//****************************************************

GenDecision::GenDecision()
{
	original=NULL;
	statistics=NULL;
	sum_stat=0;
	orig_dec_number=0;
	min_number=0;
	cur_number=-1;
}

GenDecision::~GenDecision()
{
	delete [] original;
	delete [] statistics;
}

void GenDecision::SetDecNo(int n)
{
	orig_dec_number=n;
	delete [] original;
	original=new int [n];
	delete [] statistics;
	statistics=new double [n];
	for(int i=0;i<n;i++) 
	{
		statistics[i]=0;
		original[i]=NULL_VALUE;
	}
	min_number=n+1;
	cur_number=n;
}

int GenDecision::AddValue(int v,double fitness)
{
	for(int i=0;i<orig_dec_number;i++)
	{
		if(original[i]==v) 
		{
			statistics[i]+=fitness;
			sum_stat+=fitness;
			return i;
		}
		if(original[i]==NULL_VALUE)
		{
			original[i]=v;
			statistics[i]+=fitness;
			sum_stat+=fitness;
			return i;
		}
	}
}

int GenDecision::GetOrigDec(int i)
{
	assert(i<orig_dec_number);
	return original[i];
}

int GenDecision::GetCodedDec(int v)
{
	for(int i=0;i<orig_dec_number;i++)
	{
		if(original[i]==v) return i;
	}
	assert(0);
	return -1;
}
