#include "rs_ctrl.h"

double scal_min=0,scal_max=1;
time_t stop=0,start=0;

void (*send_message)(double)=NULL;
int (*stopped)(void)=NULL;


void SetFunctions(void(*f1)(double),int(*f2)(void))
{
  send_message=f1;
  stopped=f2;
}

void SetScale(double min,double max)
{
  scal_min=min;
  scal_max=max;
}

void SetCounter(int t)
{
  if(t>0) 
  {
	  start=time(NULL);
	  stop=start+t;
  }
  else 
  {
	  stop=0;
	  start=0;
  }
}

int Percent(double p)
{
  if((stop>0)&&(time(NULL)>stop))
  {
	 stop=0;
	 throw TimeOut();
  }
  if((stopped!=NULL)&&((*stopped)()==1)) throw UserStop();
  if((stop==0)&&(send_message!=NULL)&&(p>=0))
	 (*send_message)(scal_min+p*(scal_max-scal_min));
  if((stop>0)&&(send_message!=NULL)&&(p>=0))
	 (*send_message)(scal_min+((time(NULL)-start)/double(stop-start))*(scal_max-scal_min));
  return stop;
}

